/*
 * KOTETU:
 *
 *
 * misc.c - misc
 *
 * $Id$
 *
 */

/*
 * misc macros
 */
#define strcmp_first_all(x, y0, y)      (x[0]==y0 && strcmp(x,y)==0)
#define Nstrcmp_first_all(x, y0, y)     (x[0]!=y0 || strcmp(x,y)!=0)
#define strcmp_first3(x, y0, y1, y2)    (x[0]==y0 && x[1]==y1 && x[2]==y2)
#define Nstrcmp_first3(x, y0, y1, y2)   (x[0]!=y0 || x[1]!=y1 || x[2]!=y2)
#define strncmp_first_all(x, n, y0, y)  (x[0]==y0 && strncmp(x,y,n)==0)
#define Nstrncmp_first_all(x, n, y0, y) (x[0]!=y0 || strncmp(x,y,n)!=0)
#define strcasecmp_first_all(x, y0, y) \
            ((x[0]==y0 || tolower(x[0])==tolower(y0)) && strcasecmp(x,y)==0)
#define Nstrcasecmp_first_all(x, y0, y) \
            ((x[0]!=y0 && tolower(x[0])!=tolower(y0)) || strcasecmp(x,y)!=0)
#define strncasecmp_first_all(x, n, y0, y) \
            ((x[0]==y0 || tolower(x[0])==tolower(y0)) && strncasecmp(x,y,n)==0)
#define Nstrncasecmp_first_all(x, n, y0, y) \
            ((x[0]!=y0 && tolower(x[0])!=tolower(y0)) || strncasecmp(x,y,n)!=0)


void dump_stringsegment(char *prefix, char *str, int len);
int enc_stringsegment(char *,char *prefix, char *str, int len);
void dump_string(char *prefix ,char *line );
void dump_stringchunk(char *prefix ,char *chunk);

char *display_sec (time_t t );
char *display_msec (time_t t );
char *Chop_CRLF (char *line );
char *sgets (char *hbuf ,char *pos ,char *buf ,int blen );

char *conv_byte(off_t);             /* return "XXXXKB"      */
char *conv_byte_real(off_t);        /* return "XXXX.XXKB"   */

int pathcat(char *dst, char *pre, char *fol);
int pathncat(char *dst, int n, char *pre, char *fol);


#if 0
/* nanosleep is useful, because it is MT-safe and supports very short time.
 * however, nsec is too short for network I/O.
 * then, msleep is made.
 */
inline
int
msleep(int x)
{
    struct timespec w;

    w.tv_sec = 0;
    w.tv_nsec = x * 1000000;   /* convert msec to nsec */

    nanosleep(&w, NULL);

    return 0;
}

#endif

