/*
 * KOTETU: reqeust accept procedures
 *      by k-chinen@is.aist-nara.ac.jp, 1994, 1995
 *
 * $Id: accept.h,v 1.2 1995/10/09 10:07:27 k-chinen Exp k-chinen $
 */

#ifndef KOTETU_ACCEPT_H
#define KOTETU_ACCEPT_H

#ifndef ACCEPT_TABLE_MAX
#define ACCEPT_TABLE_MAX    32
#endif

typedef
    struct {
        unsigned char addr[5];
        unsigned char mask[5];
    } accept_table_rec;

#if 0
static int accept_last=0;
static accept_table_rec table[ACCEPT_TABLE_MAX];
#endif


#define RECEPTION_TIMEOUT   3

/*
 * Misc macros (syntex suger)
 */
#define set_addr(ad, a, b, c, d) \
    ad[0] = a; ad[1] = b; ad[2] = c; ad[3] = d; ad[4] = 0

#define show_addr(pre, ad)      raw_show_addr(pre, ad)

#define old_show_addr(pre, ad) \
    Trace("%s: v4addr decimal %u.%u.%u.%u. (hex %02x%02x%02x%02x)\n", \
        pre, (unsigned char)ad[0], (unsigned char)ad[1], \
            (unsigned char)ad[2], (unsigned char)ad[3], \
            (unsigned char)ad[0], (unsigned char)ad[1], \
            (unsigned char)ad[2], (unsigned char)ad[3])


int Read_Accepttable(char *fname);
int Acceptable(unsigned char *target);
int AppendAcceptEntry(char*, char*);

#endif /* KOTETU_ACCEPT_H */
